// Generated by IcedCoffeeScript 1.3.3b
(function() {
  'use strict';

  var dataset, fs, iced, shorten, util, __iced_k, __iced_k_noop,
    __slice = [].slice,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __hasProp = {}.hasOwnProperty;

  iced = {
    Deferrals: (function() {

      function _Class(_arg) {
        this.continuation = _arg;
        this.count = 1;
        this.ret = null;
      }

      _Class.prototype._fulfill = function() {
        if (!--this.count) return this.continuation(this.ret);
      };

      _Class.prototype.defer = function(defer_params) {
        var _this = this;
        ++this.count;
        return function() {
          var inner_params, _ref;
          inner_params = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
          if (defer_params != null) {
            if ((_ref = defer_params.assign_fn) != null) {
              _ref.apply(null, inner_params);
            }
          }
          return _this._fulfill();
        };
      };

      return _Class;

    })(),
    findDeferral: function() {
      return null;
    }
  };
  __iced_k = __iced_k_noop = function() {};

  util = require('util');

  fs = require('fs');

  shorten = require('goo.gl');

  dataset = (function() {
    dataset = fs.readFileSync("" + __dirname + "/../data.json", 'utf-8');
    if (dataset) return JSON.parse(dataset);
  })();

  module.exports = function() {
    var config, _ref,
      _this = this;
    config = ((_ref = this.bot_options.plugin_options) != null ? _ref['irc-js-bot-webcompat'] : void 0) || {};
    config.browsers || (config.browsers = []);
    return this.register_special_command({
      name: 'compat',
      description: 'Query web standards browser support by feature',
      admin_only: false,
      fn: function(event, input_data, output_data) {
        var browser_data, browser_name, details_uri, feature, feature_data, feature_spec_uri, message, notes, ordered_versions, query, results, shorten_err, status, support, usage_pct, version, ___iced_passed_deferral, __iced_deferrals, __iced_k;
        __iced_k = __iced_k_noop;
        ___iced_passed_deferral = iced.findDeferral(arguments);
        (function(__iced_k) {
          if (__indexOf.call(input_data.flags, '?') >= 0) {
            message = ['Syntax: compat[/ais] <feature> • Query web standards browser support by feature', '--- This command supports the following flags ---', 'a • all browsers: show compatibility for all browsers', 'i • info: show additional information for a feature (description, useful links, …)', 's • search: find a feature\'s internal name for use with the main command'];
            _this.send('notice', event.person.nick, message);
            return;
            return __iced_k();
          } else {
            (function(__iced_k) {
              if (__indexOf.call(input_data.flags, 's') >= 0) {
                query = input_data.args.trim();
                if (!query) return;
                results = [];
                for (feature in dataset.data) {
                  if ((RegExp(query, 'i')).test(feature)) results.push(feature);
                }
                if (results.length) {
                  message = "Found " + results.length + " results for query « " + query + " » " + (results.join(' • '));
                } else {
                  message = "Sorry, no results found for query « " + query + " »";
                }
                _this.send('notice', event.person.nick, message);
                return;
                return __iced_k();
              } else {
                (function(__iced_k) {
                  if (__indexOf.call(input_data.flags, 'i') >= 0) {
                    feature = input_data.args.trim();
                    return __iced_k(!(feature in dataset.data) ? message = "Sorry, « " + feature + " » is not a feature tracked by the dataset" : (feature_data = dataset.data[feature], notes = (" • " + feature_data.notes) || '', message = "« " + feature_data.title + " • " + feature_data.description + " » Status: " + dataset.statuses[feature_data.status] + " • Spec: " + feature_data.spec + notes));
                  } else {
                    feature = input_data.args.trim();
                    (function(__iced_k) {
                      var _i, _len, _ref1;
                      if (!(feature in dataset.data)) {
                        return __iced_k(message = "Sorry, « " + feature + " » is not a feature tracked by the dataset");
                      } else {
                        support = [];
                        feature_data = dataset.data[feature];
                        _ref1 = feature_data.stats;
                        for (browser_name in _ref1) {
                          if (!__hasProp.call(_ref1, browser_name)) continue;
                          browser_data = _ref1[browser_name];
                          if ((!(__indexOf.call(config.browsers, browser_name) >= 0)) && (!(__indexOf.call(input_data.flags, 'a') >= 0))) {
                            continue;
                          }
                          ordered_versions = (function() {
                            var versions;
                            versions = Object.keys(browser_data);
                            versions = versions.sort(function(a, b) {
                              var _ref2;
                              _ref2 = [a, b].map(function(item) {
                                return (item.split('-'))[0];
                              }), a = _ref2[0], b = _ref2[1];
                              return a - b;
                            });
                            return versions;
                          })();
                          for (_i = 0, _len = ordered_versions.length; _i < _len; _i++) {
                            version = ordered_versions[_i];
                            status = browser_data[version].split(' ');
                            if (__indexOf.call(status, 'y') >= 0 || __indexOf.call(status, 'a') >= 0) {
                              support.push("" + dataset.agents[browser_name].browser + " " + (version.split('-'))[0]);
                              break;
                            }
                          }
                        }
                        (function(__iced_k) {
                          __iced_deferrals = new iced.Deferrals(__iced_k, {
                            parent: ___iced_passed_deferral,
                            filename: "src\index.coffee",
                            funcname: "fn"
                          });
                          shorten(feature_data.spec, __iced_deferrals.defer({
                            assign_fn: (function() {
                              return function() {
                                shorten_err = arguments[0];
                                return feature_spec_uri = arguments[1];
                              };
                            })(),
                            lineno: 109
                          }));
                          __iced_deferrals._fulfill();
                        })(function() {
                          (function(__iced_k) {
                            __iced_deferrals = new iced.Deferrals(__iced_k, {
                              parent: ___iced_passed_deferral,
                              filename: "src\index.coffee",
                              funcname: "fn"
                            });
                            shorten("http://caniuse.com#feat=" + feature, __iced_deferrals.defer({
                              assign_fn: (function() {
                                return function() {
                                  shorten_err = arguments[0];
                                  return details_uri = arguments[1];
                                };
                              })(),
                              lineno: 111
                            }));
                            __iced_deferrals._fulfill();
                          })(function() {
                            usage_pct = (feature_data.usage_perc_y + feature_data.usage_perc_a).toFixed(2);
                            return __iced_k(__indexOf.call(input_data.flags, 'a') >= 0 ? message = "« " + feature_data.title + " » " + (support.join(' • ')) : message = "« " + feature_data.title + " » " + (support.join(' • ')) + " • Global support: " + usage_pct + "% (of which " + feature_data.usage_perc_a + "% is partial support) • Spec: " + feature_spec_uri + " • Details: " + details_uri);
                          });
                        });
                      }
                    })(__iced_k);
                  }
                })(__iced_k);
              }
            })(__iced_k);
          }
        })(function() {
          return _this.send(output_data.method, output_data.recipient, message);
        });
      }
    });
  };

}).call(this);
